/* deft.h
 *
 *
 * Xplico - Internet Traffic Decoder
 * By Gianluca Costa <g.costa@iserm.com>
 * Copyright 2007 Gianluca Costa & Andrea de Franceschi. Web: www.xplico.org
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#ifndef __DEFT_H__
#define __DEFT_H__


/* sqlite */
#define XS_DB_FILE         "/xplico/xplico.db" /* DB file path */
#define XS_DIR_PATH        "/xplico/pol_%d/sol_%d"
#define XS_MAIL_DIR_PATH   "/xplico/pol_%d/sol_%d/mail"
#define XS_HTTP_DIR_PATH   "/xplico/pol_%d/sol_%d/http"
#define XS_FILE_DIR_PATH   "/xplico/pol_%d/sol_%d/file"
#define XS_SIP_DIR_PATH    "/xplico/pol_%d/sol_%d/sip"
#define XS_FTP_DIR_PATH    "/xplico/pol_%d/sol_%d/ftp"
#define XS_IPP_DIR_PATH    "/xplico/pol_%d/sol_%d/ipp"
#define XS_PJL_DIR_PATH    "/xplico/pol_%d/sol_%d/pjl"


#define XS_MIME_PARSER     "/xplico/script/mimedump.py"
#define XS_MIME_TO         "TO:"
#define XS_MIME_FROM       "FROM:"
#define XS_MIME_SUBJECT    "SUBJECT:"

#define XS_URL_REL_1       "POSSIBLY_CONTAINER"
#define XS_URL_REL_2       "POSSIBLY_CONTAINED"
#define XS_URL_REL_3       "CONTAINER"
#define XS_URL_REL_4       "CONTAINED"
#define XS_URL_REL_5       "SERVICES"
#define XS_URL_REL_6       "NONE"


#define XS_QUERY_DIM           10240
#define XS_STR_DIM             1024
#define XS_STR_PATH            2048
#define XS_QUERY_POP_TEMPLATE        "INSERT INTO emails (sol_id, pol_id, capture_date, data_size, flow_info, receive, username, password, sender, receivers, subject, mime_path) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), %lu, '%s', 1, '%s', '%s', '%s', '%s', '%s', '%s')"
#define XS_QUERY_SMTP_TEMPLATE       "INSERT INTO emails (sol_id, pol_id, capture_date, data_size, flow_info, receive, sender, receivers, subject, mime_path) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), %lu, '%s', 0, '%s', '%s',  '%s', '%s')"
#define XS_QUERY_IMAP_TEMPLATE       "INSERT INTO emails (sol_id, pol_id, capture_date, data_size, flow_info, receive, username, password, sender, receivers, subject, mime_path) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), %lu, '%s', 1, '%s', '%s', '%s', '%s', '%s', '%s')"
#define XS_QUERY_SIP_TEMPLATE        "INSERT INTO sips (sol_id, pol_id, capture_date, flow_info, from_addr, to_addr) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s');"
#define XS_QUERY_WEB_TEMPLATE        "INSERT INTO webs (sol_id, pol_id, capture_date, flow_info, url, relation, method, response, host, content_type, rq_header, rq_body, rq_bd_size, rs_header, rs_body, rs_bd_size) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', %i, '%s', '%s', %i)"
#define XS_QUERY_FILE_TEMPLATE       "INSERT INTO files (sol_id, pol_id, capture_date, prot_id, data_size, prot_type, flow_info, url, filename, file_path, dowloaded, info_path) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), %i, %lu, '%s', '%s', '%s', '%s', '%s', '%i', '%s')"
#define XS_QUERY_FTP_TEMPLATE        "INSERT INTO ftps (sol_id, pol_id, capture_date, flow_info, url, username, password, cmd_path) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s', '%s', '%s')"
#define XS_QUERY_FTP_UPDATE          "UPDATE ftps SET upload_num=%s, download_num=%s WHERE id=%lu"
#define XS_QUERY_FTP_DATA_TEMPLATE   "INSERT INTO ftp_files (sol_id, pol_id, capture_date, flow_info, ftp_id, filename, file_path, file_size, dowloaded) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%lu', '%s', '%s', '%lu', '%i')"
#define XS_QUERY_PJL_TEMPLATE        "INSERT INTO pjls (sol_id, pol_id, capture_date, flow_info, url, pdf_path, pdf_size, pcl_path, pcl_size) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), '%s', '%s', '%s', '%lu', '%s', '%lu')"

#endif /* __DEFT_H__ */
